//
// Created by marti on 2018-10-15.
//

#include <iostream>
#include <string>
#include <stdexcept>
#include "safeIntArray.h"
using namespace std;

SafeIntArray::SafeIntArray(int size) {
    this->size = size;
    this->theArray = new int[size];
}

SafeIntArray::SafeIntArray(SafeIntArray& toCopy) {
    this->size = toCopy.size;
    this->theArray = new int[this->size];
    for (int i=0; i<this->size; i++) {
        this->theArray[i] = toCopy.theArray[i];
    }
}

SafeIntArray::~SafeIntArray() {
    delete[] this->theArray;
}

int SafeIntArray::getSize() {
    return this->size;
}

int SafeIntArray::getElement(int index) {
    if (index >= 0 && index < size) {
        return this->theArray[index];
    } else {
        throw runtime_error("SafeIntArray::getElement, index out of bound, index=" + std::to_string(index));
    }
}

void SafeIntArray::setElement(int index, int element) {
    if (index >= 0 && index < size) {
        this->theArray[index] = element;
    } else {
        throw runtime_error("SafeIntArray::setElement, index out of bound, i=" + std::to_string(index));
    }
}

int& SafeIntArray::at(int index) {
    if (index >= 0 && index < size) {
        return this->theArray[index];
    } else {
        throw runtime_error("SafeIntArray::at, index out of bound, i=" + std::to_string(index));
    }
}

int& SafeIntArray::operator[](int index) {
    return this->theArray[index];
}

SafeIntArray& SafeIntArray::operator=(const SafeIntArray& toAssign)  {
    if (this != &toAssign) {
        // delete current dynamic memory
        delete[] this->theArray;

        // copy stuff from assigned object
        this->size = toAssign.size;
        this->theArray = new int[this->size];
        for (int i=0; i<this->size; i++) {
            this->theArray[i] = toAssign.theArray[i];
        }
    }
    return *this;
}

SafeIntArray SafeIntArray::operator+(SafeIntArray &toAdd) {
    SafeIntArray sum(this->size + toAdd.size);
    for (int i=0; i<this->size; i++) {
        sum[i] = this->theArray[i];
    }
    for (int i=0; i<toAdd.size; i++) {
        sum[this->size + i] = toAdd.theArray[i];
    }
    return sum;
}

// TODO implement the 6 following functions.

string SafeIntArray::to_string() {
    throw runtime_error("SafeIntArray::to_string not implemented");
}

SafeIntArray SafeIntArray::slice(int start, int end, int inc) {
    throw runtime_error("SafeIntArray::slice not implemented");
}

SafeIntArray SafeIntArray::operator*(int rep) {
    throw runtime_error("SafeIntArray::operator* not implemented");
}

bool SafeIntArray::operator==(SafeIntArray &other) {
    throw runtime_error("SafeIntArray::operator== not implemented");
}

int SafeIntArray::find(int value) {
    throw runtime_error("SafeIntArray::find not implemented");
}

SafeIntArray SafeIntArray::reverse() {
    throw runtime_error("SafeIntArray::reverse not implemented");
}